﻿using System;
using System.IO;
using System.Diagnostics;
using Microsoft.Win32;
using IWshRuntimeLibrary;
using System.Web.Script.Serialization;

namespace AtualizadorVLibras
{
    class Requirements
    {
        //false - extrair, true - ignorar
        //ex:
        //{"Major":5,"Minor":1,"Build":1,"Revision":20}
        public static bool verificarVersao(string atual, string extraida){
            if(System.IO.File.Exists(atual)){
                if(!System.IO.File.Exists(extraida)){
                    return false;
                }
                JavaScriptSerializer serializer = new JavaScriptSerializer();

                StreamReader sr = new StreamReader(atual);
                string versaoAtual = sr.ReadToEnd();
                dynamic arrayAtual = serializer.DeserializeObject(versaoAtual);

                sr = new StreamReader(extraida);
                string versaoExtraida = sr.ReadToEnd();
                dynamic arrayExtraida = serializer.DeserializeObject(versaoExtraida);

                int atualMaj = Convert.ToInt32(arrayAtual["Major"]);
                int atualMin = Convert.ToInt32(arrayAtual["Minor"]);
                int atualBui = Convert.ToInt32(arrayAtual["Build"]);
                int atualRev = Convert.ToInt32(arrayAtual["Revision"]);

                int ExtraidaMaj = Convert.ToInt32(arrayExtraida["Major"]);
                int ExtraidaMin = Convert.ToInt32(arrayExtraida["Minor"]);
                int ExtraidaBui = Convert.ToInt32(arrayExtraida["Build"]);
                int ExtraidaRev = Convert.ToInt32(arrayExtraida["Revision"]);

				//É importante que o operador utilizado seja '!=', no lugar de '>', pq em aplicações clickonce é possível reverter versão!
                if(atualMaj != ExtraidaMaj){
                    //Console.WriteLine("Major é mais recente em version: {0} {1}", atualMaj, ExtraidaMaj);
                    return false;
                }
				if (atualMin != ExtraidaMin){
                    //Console.WriteLine("Minor é mais recente em version: {0} {1}", atualMin, ExtraidaMin);
                    return false;
                }
				if (atualBui != ExtraidaBui){
                    //Console.WriteLine("Build é mais recente em version: {0} {1}", atualBui, ExtraidaBui);
                    return false;
                }
				if (atualRev != ExtraidaRev){
                    //Console.WriteLine("Revision é mais recente em version: {0} {1}", atualRev, ExtraidaRev);
                    return false;
                }
            }
            return true;
        }
    	public static bool IsInstalled(RegistryKey[] regs){
    		foreach(RegistryKey reg in regs){
    			if(reg != null){
    				return true;
    			}
    		}
    		return false;
    	}

		public static bool IsInstalled(RegistryKey reg){
    		if(reg != null){
    			return true;
    		}else{
	    		return false;
    		}
    	}

    	public static void Uninstall(RegistryKey[] regs){
    		foreach(RegistryKey reg in regs){
    			if(IsInstalled(reg)){
    				try{
	    				Process uninsProc = new Process();
			            ProcessStartInfo uninsProcInfo = new ProcessStartInfo();
			            uninsProcInfo.WindowStyle = ProcessWindowStyle.Hidden;
			            uninsProcInfo.FileName = "cmd.exe";
			            string comandoUnins;
			            comandoUnins = "/C" + reg.GetValue("QuietUninstallString").ToString().Replace("\"", "");
			            uninsProcInfo.Arguments = comandoUnins;
			            uninsProc.StartInfo = uninsProcInfo;
			            uninsProc.Start();
			            //uninsProc.WaitForExit();
    				}catch(Exception){
    					//NOTHING
    				}
    			}
    		}
    	}

    	//CRIA ATALHO
    	public static void criaAtalho(string path){//string pathPython2){
            object shDesktop = (object)"Desktop";
            WshShell shell = new WshShell();
            string shortcutAddress = (string)shell.SpecialFolders.Item(ref shDesktop) + @"\VLibras.lnk";
            IWshShortcut shortcut = (IWshShortcut)shell.CreateShortcut(shortcutAddress);
            shortcut.Description = "VLibras";
            string vlibrasPath = Path.Combine(Directory.GetParent(Directory.GetCurrentDirectory()).FullName, @"VLibras\");
            shortcut.IconLocation = Path.Combine(vlibrasPath, @"icon_vlibras.ico");
            //shortcut.Hotkey = "Ctrl+Shift+N";
            shortcut.TargetPath = Path.Combine(vlibrasPath, @"Player\vlibrasPlayer.exe");
			shortcut.WorkingDirectory = Path.Combine(vlibrasPath, @"Player\");
			shortcut.Save();

//		    //string driveAtual = @" % HOMEPATH%\..\..";
//		    //string pathPython2 = driveAtual+@"Python27\python.exe";
//		    //string pathPython2 = Environment.GetEnvironmentVariable("PYTHONPATH", EnvironmentVariableTarget.Machine);
//
//            //string pathPython2 = GetRegistroPythonPath();
//		    int idx = pathPython2.IndexOf(@";");
//		    //pathPython2 = pathPython2.Remove(idx, pathPython2.Length - idx);
//		    //pathPython2 = "\""+pathPython2 + "\\python.exe\"";
//
//		    //Console.WriteLine("VERIFICAÇÃO DA LINHA criaAtalho: "+pathPython2);
//		    //Console.ReadKey();
//
//            ProcessStartInfo procInfo = new ProcessStartInfo();
//            procInfo.FileName = pathPython2;//"cmd.exe";
//		    //procInfo.Arguments = "/C py -2 "+Directory.GetCurrentDirectory()+@"\criaLnk.py";
//		    //procInfo.Arguments = "/C "+pathPython2+" -m "+Directory.GetCurrentDirectory()+@"\criaLnk.py";
//		    //procInfo.Arguments = "/C "+pathPython2+" \""+Directory.GetCurrentDirectory()+"\\criaLnk.py\"";
//		    procInfo.Arguments = "\""+Directory.GetCurrentDirectory()+@"\criaLnk.py";
//		    procInfo.UseShellExecute = false;
//		    procInfo.RedirectStandardOutput = true;
//		    procInfo.WindowStyle = ProcessWindowStyle.Hidden;
//
//		    //Process process = new Process();
//		    //process.StartInfo = procInfo;
//		    //process.Start();
//	        using(Process process = Process.Start(procInfo)){
//	            using(StreamReader reader = process.StandardOutput){
//	                string result = reader.ReadToEnd();
//	                Console.Write(result);
//	            }
//	            process.WaitForExit();
//	        }
//	        //Console.WriteLine("pausa: {0}",procInfo.Arguments);
//	        //Console.ReadKey();
    	}

    	//NÃO VAI SER MAIS UTILIZADO DEVIDO AO PYTHON PORTÁTIL
    	public static string GetRegistroPythonPath(){
    		var lm64 = RegistryKey.OpenBaseKey(RegistryHive.LocalMachine, RegistryView.Registry64);
            var lm32 = RegistryKey.OpenBaseKey(RegistryHive.LocalMachine, RegistryView.Registry32);
        	var cr64 = RegistryKey.OpenBaseKey(RegistryHive.ClassesRoot, RegistryView.Registry64);
            var cr32 = RegistryKey.OpenBaseKey(RegistryHive.ClassesRoot, RegistryView.Registry32);
        	var cu64 = RegistryKey.OpenBaseKey(RegistryHive.CurrentUser, RegistryView.Registry64);
            var cu32 = RegistryKey.OpenBaseKey(RegistryHive.CurrentUser, RegistryView.Registry32);

    		RegistryKey pythonReg = null;
        	if(lm64.OpenSubKey(@"SOFTWARE\Python\PythonCore\2.7\InstallPath") != null){
	        	pythonReg = lm64.OpenSubKey(@"SOFTWARE\Python\PythonCore\2.7\InstallPath");
        	}
        	if(lm32.OpenSubKey(@"SOFTWARE\Python\PythonCore\2.7\InstallPath") != null){
        		pythonReg = lm32.OpenSubKey(@"SOFTWARE\Python\PythonCore\2.7\InstallPath");
        	}
        	if(cu64.OpenSubKey(@"SOFTWARE\Python\PythonCore\2.7\InstallPath") != null){
        		pythonReg = cu64.OpenSubKey(@"SOFTWARE\Python\PythonCore\2.7\InstallPath");
        	}
        	if(cu32.OpenSubKey(@"SOFTWARE\Python\PythonCore\2.7\InstallPath") != null){
        		pythonReg = cu32.OpenSubKey(@"SOFTWARE\Python\PythonCore\2.7\InstallPath");
        	}
        	if(lm64.OpenSubKey(@"SOFTWARE\Wow6432Node\Python\PythonCore\2.7\InstallPath") != null){
        		pythonReg = lm64.OpenSubKey(@"SOFTWARE\Wow6432Node\Python\PythonCore\2.7\InstallPath");
        	}
        	if(lm32.OpenSubKey(@"SOFTWARE\Wow6432Node\Python\PythonCore\2.7\InstallPath") != null){
        		pythonReg = lm32.OpenSubKey(@"SOFTWARE\Wow6432Node\Python\PythonCore\2.7\InstallPath");
        	}
        	if(cu64.OpenSubKey(@"SOFTWARE\Wow6432Node\Python\PythonCore\2.7\InstallPath") != null){
        		pythonReg = cu64.OpenSubKey(@"SOFTWARE\Wow6432Node\Python\PythonCore\2.7\InstallPath");
        	}
        	if(cu32.OpenSubKey(@"SOFTWARE\Wow6432Node\Python\PythonCore\2.7\InstallPath") != null){
        		pythonReg = cu32.OpenSubKey(@"SOFTWARE\Wow6432Node\Python\PythonCore\2.7\InstallPath");
        	}
        	if(pythonReg != null){
        		//CONIFGURAÇÃO DA VARIÁVEL PYTHONPATH
        		string python = pythonReg.GetValue(null).ToString();
        		//python = python.Remove(python.Length - 1).ToString();
	        	return "\""+python+@"python.exe"+"\"";
        	}else{
        		return "";
        	}
    	}

    	//NÃO VAI SER MAIS UTILIZADO DEVIDO AO PYTHON PORTÁTIL
    	//INSTALA, SE NECESSÁRIO, OS MÓDULOS DO PYTHON
    	public static void InstallWheels(bool force){
            /*var cr64 = RegistryKey.OpenBaseKey(RegistryHive.ClassesRoot, RegistryView.Registry64);
            var cr32 = RegistryKey.OpenBaseKey(RegistryHive.ClassesRoot, RegistryView.Registry32);
    		RegistryKey pythonShell = cr64.OpenSubKey(@"Python.File\Shell\open\command");
            if(pythonShell == null){
                pythonShell = cr32.OpenSubKey(@"Python.File\Shell\open\command");
            }
            path do python na máquina
            string pythonCMD = pythonShell.GetValue(null).ToString();
            pythonCMD = pythonCMD.Remove(pythonCMD.Length - 9).Replace("\"", "");
		    procInfo.FileName = pythonCMD;*/

            //INFORMAÇÕES SOBRE O PROCESSO QUE VAI SER INICIADO
            //string driveAtual = @"%HOMEPATH%\..\..";
		    //string pathPython2 = driveAtual+@"Python27\python.exe";

		    //string pathPython2 = Environment.GetEnvironmentVariable("PYTHONPATH", EnvironmentVariableTarget.Machine);
		    string pathPython2 = GetRegistroPythonPath();
		    int idx = pathPython2.IndexOf(@";");
		    //pathPython2 = pathPython2.Remove(idx, pathPython2.Length - idx);
		    //pathPython2 = "\""+pathPython2 + "\\python.exe\"";

		    //Console.WriteLine("VERIFICAÇÃO DA LINHA insWhls: "+pathPython2);
		    //Console.ReadKey();
            //ATUALIZAÇÃO DO PIP
            ProcessStartInfo procInfo = new ProcessStartInfo();
            //procInfo.FileName = "py";
            //procInfo.Arguments = "-2 -m pip install --upgrade pip";
            procInfo.FileName = pathPython2;
            procInfo.Arguments = "-m pip install --upgrade pip";
		    procInfo.UseShellExecute = false;
		    procInfo.RedirectStandardOutput = true;
		    procInfo.WindowStyle = ProcessWindowStyle.Hidden;

		    //Process process = new Process();
		    //process.StartInfo = procInfo;
		    //process.Start();
		    //process.WaitForExit();
            string result = "";
		    using(Process process = Process.Start(procInfo)){
	            using(StreamReader reader = process.StandardOutput){
                    while(!reader.EndOfStream){
    	                result = reader.ReadLine() + "\n";
    	                Console.Write(result);
                    }
	            }
	            process.WaitForExit();
	        }
		    Console.WriteLine("Pip atualizado.");
		    Console.WriteLine("Instalando os módulos. Isso pode levar alguns minutos. Por favor, aguarde.");
		    //INSTALAÇÃO DOS MÓDULOS
            if(force){
            	//instalação forçada
            	//procInfo.Arguments = "-2 "+Directory.GetCurrentDirectory()+@"\checkwheels.py --force";
            	//procInfo.Arguments = "-m "+Directory.GetCurrentDirectory()+@"\checkwheels.py --force";
            	procInfo.Arguments = "\""+Directory.GetCurrentDirectory()+@"\checkwheels.py"+"\""+" --force";
           	}else{
			    //procInfo.Arguments = "-2 "+Directory.GetCurrentDirectory()+@"\checkwheels.py";
			    //procInfo.Arguments = "-m "+Directory.GetCurrentDirectory()+@"\checkwheels.py";
			    procInfo.Arguments = "\""+Directory.GetCurrentDirectory()+@"\checkwheels.py"+"\"";
           	}
           	//Console.WriteLine("VERIFICAÇÃO DA LINHA insWhls2: "+procInfo.Arguments);
		    //Console.ReadKey();
            //process = new Process();
		    //process.StartInfo = procInfo;
		    //process.Start();
		    //process.WaitForExit();
            result = "";
		    using(Process process = Process.Start(procInfo)){
	            using(StreamReader reader = process.StandardOutput){
	                while(!reader.EndOfStream){
                        result = reader.ReadLine() + "\n";
                        Console.Write(result);
                    }
	            }
	            process.WaitForExit();
	        }
		}


		//SE FOR USAR BOTAR PYTHONPATH2 ENTRE ASPAS!!!!!!!!!!
		/*public static bool ChecarVersaoPython(){
			string driveAtual = @"%HOMEPATH%\..\..";
		    string pathPython2 = driveAtual+@"Python27\python.exe";

			//string comandoIns = "/C py -2 --version";
			string comandoIns = @"/C "+"\""pathPython2+"\""+" --version";
			//Process e Process Information
            ProcessStartInfo insProcInfo = new ProcessStartInfo();
            Process insProc = new Process();

            insProcInfo.WindowStyle = ProcessWindowStyle.Hidden;
            insProcInfo.FileName = "cmd.exe";
            insProcInfo.Arguments = comandoIns;
            insProcInfo.UseShellExecute = false;
            insProcInfo.CreateNoWindow = true;
            insProcInfo.RedirectStandardError = true;
            //insProcInfo.Verb = "runas"; //ADM

            insProc.StartInfo = insProcInfo;
            insProc.Start();
            string output = insProc.StandardError.ReadToEnd();
            insProc.WaitForExit();
            if(output == null || output == ""){
            	return false;
            }
            output = output.Remove(output.Length-2);
            string version = output.Replace("Python ", "");
            string majorMinorVersion = version.Remove(3);
            if(majorMinorVersion.Equals("2.7")){
            	string patchVersion = version.Replace("2.7.","");
            	int x = -1;
            	int.TryParse(patchVersion, out x);
            	if(x >= 9){
            		return true;
            	}
            }
            return false;
        }*/

    	public static void Install(string pathInstaller64, string pathInstaller86){
    		string pathInstaller;
    		if(Environment.Is64BitOperatingSystem){
                pathInstaller = pathInstaller64;
            }else{
            	pathInstaller = pathInstaller86;
			}
			if(pathInstaller == ""){
				return;
			}
			//string comandoIns = "/C" + pathInstaller + " -s -v -qn";
			string comandoIns = @"msiexec /i "+"\""+pathInstaller+"\""+@" /quiet /qn /norestart";
			//Process e Process Information
            ProcessStartInfo insProcInfo = new ProcessStartInfo();
            Process insProc = new Process();

            insProcInfo.WindowStyle = ProcessWindowStyle.Hidden;
            insProcInfo.FileName = "cmd.exe";
            insProcInfo.Arguments = comandoIns;
            //insProcInfo.Verb = "runas"; //ADM

            insProc.StartInfo = insProcInfo;
            insProc.Start();
            //insProc.WaitForExit();
    	}

    	public static void Install(string pathInstaller64, string pathInstaller86, string args){
    		string pathInstaller;
    		if(Environment.Is64BitOperatingSystem){
                pathInstaller = pathInstaller64;
            }else{
            	pathInstaller = pathInstaller86;
			}
			if(pathInstaller == ""){
				return;
			}
			//string comandoIns = "/C" + pathInstaller + " -s -v -qn";
			string comandoIns = @"msiexec /i "+"\""+pathInstaller+"\" "+args;
			//Process e Process Information
            ProcessStartInfo insProcInfo = new ProcessStartInfo();
            Process insProc = new Process();

            insProcInfo.WindowStyle = ProcessWindowStyle.Hidden;
            insProcInfo.FileName = "cmd.exe";
            insProcInfo.Arguments = comandoIns;
            //insProcInfo.Verb = "runas"; //ADM

            insProc.StartInfo = insProcInfo;
            insProc.Start();
            //insProc.WaitForExit();
    	}

    	public static void InstallAndWait(string pathInstaller64, string pathInstaller86){
    		string pathInstaller;
    		if(Environment.Is64BitOperatingSystem){
                pathInstaller = pathInstaller64;
            }else{
            	pathInstaller = pathInstaller86;
			}
			if(pathInstaller == ""){
				return;
			}
			//string comandoIns = "/C" + pathInstaller + " -s -v -qn";
			string comandoIns = @"/i "+"\""+pathInstaller+"\"";
			//Process e Process Information
            ProcessStartInfo insProcInfo = new ProcessStartInfo();
            //insProcInfo.WindowStyle = ProcessWindowStyle.Hidden;
            Process insProc = new Process();

            insProcInfo.FileName = "msiexec";
            insProcInfo.Arguments = comandoIns;
            //insProcInfo.Verb = "runas"; //ADM
            //Console.WriteLine("VERIFICAÇÃO DE LINHA insWait: "+ insProcInfo.Arguments);
            //Console.ReadKey();
            insProc.StartInfo = insProcInfo;
            insProc.Start();
            insProc.WaitForExit();
    	}

    	//qn - instalação sem interface, passive instalação passiva
    	public static void InstallAndWait(string pathInstaller64, string pathInstaller86, string args){
    		string pathInstaller;
    		if(Environment.Is64BitOperatingSystem){
                pathInstaller = pathInstaller64;
            }else{
            	pathInstaller = pathInstaller86;
			}
			if(pathInstaller == ""){
				return;
			}
			//string comandoIns = "/C" + pathInstaller + " -s -v -qn";
			string comandoIns = @"/i "+"\""+pathInstaller+"\" "+args;
			//Process e Process Information
            ProcessStartInfo insProcInfo = new ProcessStartInfo();
            //insProcInfo.WindowStyle = ProcessWindowStyle.Hidden;
            Process insProc = new Process();

            insProcInfo.FileName = "msiexec";
            insProcInfo.Arguments = comandoIns;
            //insProcInfo.Verb = "runas"; //ADM

            insProc.StartInfo = insProcInfo;
            insProc.Start();
            insProc.WaitForExit();
    	}

    }
}
